#pragma semicolon 1

#include <sourcemod>
#include <cstrike>

public Plugin:myinfo = 
{
	name	= "Spawn Time Control",
	author	= "wS",
	url		= "http://world-source.ru/",
	version = "1.2.2"
};

new Handle:g_hPlayerTeamTimer[MAXPLAYERS + 1] = {INVALID_HANDLE, ...};
new stc_sec, round_start_time;
new Handle:g_hTrie;

public OnPluginStart() {
	g_hTrie = CreateTrie();
	
	//
	new Handle:hCvar = CreateConVar("stc_sec", "10.0", "В течение скольки сек, после начала раунда, можно вступить в игру живым", _, true, 1.0);
	stc_sec = GetConVarInt(hCvar);
	HookConVarChange(hCvar, stc_sec_);
	//
	
	HookEvent("round_start" , round_start , EventHookMode_PostNoCopy);
	HookEvent("player_team" , player_team , EventHookMode_Post);
	HookEvent("player_death", player_death, EventHookMode_Post);
}

public OnMapEnd() {
	ClearTrie(g_hTrie);
}

public stc_sec_(Handle:hCvar, const String:OldValue[], const String:NewValue[]) {
	stc_sec = StringToInt(NewValue);
}

public round_start(Handle:event, const String:name[], bool:silent) {
	round_start_time = GetTime();
	ClearTrie(g_hTrie);
}

public player_death(Handle:event, const String:name[], bool:silent) {
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (client > 0) {
		BlockRespawn(client);
	}
}

public player_team(Handle:event, const String:name[], bool:silent) {
	if (GetEventInt(event, "team") > 1) {
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		if (client > 0 && g_hPlayerTeamTimer[client] == INVALID_HANDLE && !IsFakeClient(client)) {
			g_hPlayerTeamTimer[client] = CreateTimer(0.5, player_team_timer, client);
		}
	}
}

public Action:player_team_timer(Handle:timer, any:client) {
	g_hPlayerTeamTimer[client] = INVALID_HANDLE;
	if (IsClientInGame(client) && LivePlayers(client)) {
		if (IsPlayerAlive(client)) {
			if (!CanSpawn()) {
				ChangeClientTeam(client, 1);
			}
		}
		else if (GetClientTeam(client) > 1 && CanSpawn() && BlockRespawn(client)) {
			CS_RespawnPlayer(client);
		}
	}
	return Plugin_Stop;
}

public OnClientDisconnect(client) {
	if (g_hPlayerTeamTimer[client] != INVALID_HANDLE) {
		KillTimer(g_hPlayerTeamTimer[client]);
		g_hPlayerTeamTimer[client] = INVALID_HANDLE;
	}
}

bool:LivePlayers(ignore_client) { // Должны быть живы хотя бы 1 T и 1 CT (2 игрока)
	for (new i = 1, t = 0; i <= MaxClients; i++) {
		if (i != ignore_client && IsClientInGame(i) && IsPlayerAlive(i)) {
			if (!t) {
				t = GetClientTeam(i);
			}
			else if (t != GetClientTeam(i)) {
				return true;
			}
		}
	}
	return false;
}

bool:CanSpawn() {
	return (GetTime() - round_start_time) <= stc_sec;
}

bool:BlockRespawn(client) {
	decl String:steamid[32];
	return GetClientAuthId(client, AuthIdType:AuthId_Steam3, steamid, sizeof(steamid)) && SetTrieValue(g_hTrie, steamid, 1, false);
}